package jMoneyAtHome;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;

/** This class holds a dialog for the data after the shopping.
 *
 * @author Markus Iofcea
 */
public class PurchaseDialog extends javax.swing.JDialog {
  
  /** Creates new form PurchaseDialog. This is the main constructor.
   * @param parent This variable holds the parent frame of this dialog
   * @param modal This variable tells if this dialog should be modal
   * @param db Over this variable the PurchaseDialog gets the database connection
   * to insert the values.
   */
  public PurchaseDialog(java.awt.Frame parent, boolean modal, DBConnectivity db) {
    super(parent, modal);
    baseFrame=(MainGUI)parent;
    dbcon = db;
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
    buttonPanel = new javax.swing.JPanel();
    okButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();
    outerMainPanel = new javax.swing.JPanel();
    mainPanel = new javax.swing.JPanel();
    necessityCheckBox = new javax.swing.JCheckBox();
    labelPanel = new javax.swing.JPanel();
    dateLabel = new javax.swing.JLabel();
    whereLabel = new javax.swing.JLabel();
    costsLabel = new javax.swing.JLabel();
    textFieldPanel = new javax.swing.JPanel();
    dateTextFieldPanel = new javax.swing.JPanel();
    dayTextField = new javax.swing.JTextField();
    jLabel2 = new javax.swing.JLabel();
    monthTextField = new javax.swing.JTextField();
    jLabel3 = new javax.swing.JLabel();
    yearTextField = new javax.swing.JTextField();
    whereTextFieldPanel = new javax.swing.JPanel();
    whatTextField = new javax.swing.JTextField();
    costsPanel = new javax.swing.JPanel();
    euroTextField = new javax.swing.JTextField();
    jLabel1 = new javax.swing.JLabel();

    setTitle("Purchase");
    setResizable(false);
    addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent evt) {
        closeDialog(evt);
      }
    });

    okButton.setText("OK");
    okButton.setFocusPainted(false);
    okButton.setPreferredSize(null);
    okButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        okButtonActionPerformed(evt);
      }
    });

    buttonPanel.add(okButton);

    cancelButton.setText("Cancel");
    cancelButton.setFocusPainted(false);
    cancelButton.setPreferredSize(null);
    cancelButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cancelButtonActionPerformed(evt);
      }
    });

    buttonPanel.add(cancelButton);

    getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);

    mainPanel.setLayout(new java.awt.BorderLayout(5, 5));

    necessityCheckBox.setText("Necessity");
    necessityCheckBox.setFocusPainted(false);
    mainPanel.add(necessityCheckBox, java.awt.BorderLayout.SOUTH);

    labelPanel.setLayout(new java.awt.GridLayout(3, 0, 0, 5));

    dateLabel.setText("Date (dd-mm-yy):");
    labelPanel.add(dateLabel);

    whereLabel.setText("What:");
    labelPanel.add(whereLabel);

    costsLabel.setText("Costs:");
    labelPanel.add(costsLabel);

    mainPanel.add(labelPanel, java.awt.BorderLayout.WEST);

    textFieldPanel.setLayout(new java.awt.GridLayout(3, 0));

    dateTextFieldPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    dayTextField.setColumns(2);
    int d;
    String day;
    d = calendar.get(Calendar.DATE);
    day = Integer.toString(d);
    dayTextField.setText(day);
    dateTextFieldPanel.add(dayTextField);

    jLabel2.setText("-");
    dateTextFieldPanel.add(jLabel2);

    monthTextField.setColumns(2);
    int m;
    String month;
    m=calendar.get(Calendar.MONTH)+1;
    month = Integer.toString(m);
    monthTextField.setText(month);
    dateTextFieldPanel.add(monthTextField);

    jLabel3.setText("-");
    dateTextFieldPanel.add(jLabel3);

    yearTextField.setColumns(4);
    int y;
    String year;
    y = calendar.get(Calendar.YEAR);
    year = Integer.toString(y);
    yearTextField.setText(year);
    dateTextFieldPanel.add(yearTextField);

    textFieldPanel.add(dateTextFieldPanel);

    whereTextFieldPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    whatTextField.setColumns(10);
    whereTextFieldPanel.add(whatTextField);

    textFieldPanel.add(whereTextFieldPanel);

    costsPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

    euroTextField.setColumns(7);
    costsPanel.add(euroTextField);

    jLabel1.setText("EUR");
    costsPanel.add(jLabel1);

    textFieldPanel.add(costsPanel);

    mainPanel.add(textFieldPanel, java.awt.BorderLayout.CENTER);

    outerMainPanel.add(mainPanel);

    getContentPane().add(outerMainPanel, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
    try {
      double costs;
      int day,month,year;
      costs = Double.parseDouble(euroTextField.getText());
      day   = Integer.parseInt(dayTextField.getText());
      month = Integer.parseInt(monthTextField.getText())-1;
      year  = Integer.parseInt(yearTextField.getText());
      calendar.set(year,month,day);
      long l=calendar.getTimeInMillis();
      date = new java.sql.Date(l); 
      String query;
      if (necessityCheckBox.isSelected()) {
        query = "insert into jMoneyAtHome set date=\""+date.toString()+"\", what=\""+whatTextField.getText()+"\", costs="+Double.toString(costs)+", who_paid=\""+baseFrame.name+"\", necessity=1";
      } else {
        query = "insert into jMoneyAtHome set date=\""+date.toString()+"\", what=\""+whatTextField.getText()+"\", costs="+Double.toString(costs)+", who_paid=\""+baseFrame.name+"\", necessity=0";
      }
      if (dbcon.insertData(query)) {
        baseFrame.refreshView();
        setVisible(false);
        dispose();      
      }
    } catch (NumberFormatException nfe) {
      baseFrame.errorDialog("Wrong number format! There must be a letter in one of the number textfields!");
    }
    
  }//GEN-LAST:event_okButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
    setVisible(false);
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  /** Closes the dialog */
  private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
    setVisible(false);
    dispose();
  }//GEN-LAST:event_closeDialog
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel whereTextFieldPanel;
  private javax.swing.JPanel textFieldPanel;
  private javax.swing.JPanel buttonPanel;
  private javax.swing.JPanel labelPanel;
  private javax.swing.JButton okButton;
  private javax.swing.JTextField monthTextField;
  private javax.swing.JTextField whatTextField;
  private javax.swing.JLabel dateLabel;
  private javax.swing.JTextField euroTextField;
  private javax.swing.JPanel costsPanel;
  private javax.swing.JCheckBox necessityCheckBox;
  private javax.swing.JTextField dayTextField;
  private javax.swing.JTextField yearTextField;
  private javax.swing.JPanel outerMainPanel;
  private javax.swing.JLabel costsLabel;
  private javax.swing.JLabel whereLabel;
  private javax.swing.JButton cancelButton;
  private javax.swing.JPanel mainPanel;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JPanel dateTextFieldPanel;
  // End of variables declaration//GEN-END:variables

  MainGUI baseFrame;  
  java.sql.Date date;
  Calendar calendar = new GregorianCalendar();
  DBConnectivity dbcon;
}
